#!/usr/bin/python

# Thanks, amac777 from http://ubuntuforums.org/showthread.php?t=1365724 !

from __future__ import division
import sys
from subprocess import Popen, PIPE
from threading import Thread

import gtk, glib
import pyexiv2


def Worker( d ):
    files = list( sys.argv[1:] )
    how_many = len( files )

    l = gtk.Label( '0 / %d' % how_many )
    l.show()

    prog = gtk.ProgressBar()
    prog.set_fraction( 0 )
    prog.show()

    d.action_area.pack_start( l )
    d.action_area.pack_start( prog )

    done = 0
    while files:
        try:
            if p.poll() == None:
                yield True
                continue
            else:
                done += 1
                prog.set_fraction( done / how_many )
                l.set_text( '%d / %d' % (done, how_many) )
        except NameError:
            # First run
            pass
        
        try:
            f = files.pop()
            image = pyexiv2.Image( f )
        except IOError:
            # Image non recognized
            continue

        image.readMetadata()
        date = image['Exif.Photo.DateTimeDigitized']
        date_str = date.strftime("%y%m%d%H%M")
        
        p = Popen( ('touch -t %s %s' % (date_str, f )).split() )
        yield True
    
    d.hide()
    yield False



if __name__ == '__main__':
    d = gtk.Dialog()
    worker = Worker( d )
    glib.timeout_add( 10, worker.next )
    d.run()
